/*
 * This file: wscrawl.h
 */
#define FALSE			0	/* general defines */
#define TRUE			1
#define NUM_MENUS		5	/* number of menus such as "File"... */
#define SERV_TCP_PORT		6004	/* arbitrary port number for knocking */
#define FATBITS_MAG             10      /* fatbits magnifies by this factor */
#define OK			1	/* responses to certain dialogs */
#define CANCEL			0

#define ACTIVATE		2  	/* some constants for callbacks */
#define ARM			3
#define DISARM			4

#define ENGLISH			0  	/* responses in the language dialog */
#define GERMAN			1 
#define LANGUAGE_OK		2 
#define LANGUAGE_CANCEL		3 

#define BELL			0  	/* responses in the attract attention */
#define FLASH			1 
#define ATTENTION_CLOSE		2 

#define MOUSE_COORDINATES	0  	/* responses in the mouse dialog */
#define MOUSE_TELEPOINTER	1 
#define MOUSE_GRID		2 
#define MOUSE_CLOSE		3 

#define ERASE_VISIBLE		0  	/* responses in the eraser dialog */
#define ERASE_ALL_WHITEBOARD	1 
#define ERASER_OK		2 
#define ERASER_CANCEL		3 

#define SUPER_SEL		0  	/* responses in the selection dialog */
#define FREEZE_SUPER_SEL	1 
#define WAIT_FREEZE_SUPER_SEL	2 
#define SELECTION_CANCEL	3 

#define BITMAP_FORMAT		0  	/* responses in the file type dialog */
#define XWD_FORMAT		1 
#define TEXT_FILE_FORMAT	2 
#define GREYSCALE_POSTSCRIPT	4 
#define PPM_FORMAT		5 
#define FILE_IO_CANCEL		6 

#define SCROLL_SYNC		0  	/* responses in the scrollbar dialog */
#define SCROLL_A_SYNC		1 
#define SCROLL_CANCEL		2 

#define COPY_ALL		0  	/* responses in the dirty_add_display */
#define COPY_VIS		1 
#define CLEAR_ALL		2 
#define ADD_CANCEL		3 

#define RED_SLIDER		0  	/* actions in the color_picker */
#define GREEN_SLIDER		1 
#define BLUE_SLIDER		2 
#define ALLOCATE_COLOR		3 
#define GRAB_COLOR		4 
#define COLOR_CANCEL		5 

#define FATBITS_SELECTION_BUT	0    	/* actions in the fatbits editor */
#define FATBITS_PENCIL_BUT	1    
#define FATBITS_ERASER_BUT	2 
#define FATBITS_CLOSE		3 

#define BRUSH_OK		25      /* brush dialog responses */

#define NORMAL			0       /* paint mode */
#define BITMAP_BRUSH		1   

#define MAX_ARGS		30	/* various max numbers */
#define MAX_NUM_DISPS 		10
#define MAX_NUM_MENU_ITEMS 	25
#define MAX_NUM_TOOLS 		16
#define MAX_NUM_BRUSH_POINTS	100
#define MAX_HOST_NAME_LENGTH 	50
#define MAX_RAND 		((1<<15) - 1)

#define POINTING		0    	/* possible values for "input_mode" */
#define SELECTING		1
#define SUPER_SELECTING		2
#define PAINTING		3
#define PENCILING		4
#define TYPING			5 
#define ERASING			6 
#define SPRAYPAINTING		7 
#define DRAWING_LINES		8 
#define OUTLINING_SQUARES	9 
#define FILLING_SQUARES		10 
#define OUTLINING_OVALS		11 
#define FILLING_OVALS		12
#define DRAGGING_SELECTION	13
#define GRABBING_COLOR		14

#define POINTER_BUTTON		0    	/* all the tools on the tool palette */
#define SELECTION_BUTTON	1    	
#define PENCIL_BUTTON		2    
#define TYPE_BUTTON		3 
#define PAINTBRUSH_BUTTON	4 
#define SPRAYCAN_BUTTON 	5 
#define ERASER_BUTTON 		6 
#define LINE_BUTTON 		7 
#define OUTLINESQUARE_BUTTON	8 
#define FILLSQUARE_BUTTON	9 
#define OUTLINEOVAL_BUTTON	10 
#define FILLOVAL_BUTTON		11 

#define PRESSED			0    	/* possible values for "pointer_state"*/
#define NOT_PRESSED		1 

#define FILE_MENU		0    	/* menus in the menu bar */
#define EDIT_MENU		1
#define OPTIONS_MENU		2
#define COLOR_MENU		3
#define FONT_MENU		4
#define TELECONF_MENU		5

#define ADD_DISPLAY		0    	/* FILE_MENU item selections */
#define JOIN_EXISTING_SESSION	1
#define ATTRACT_ATTENTION	2
#define SAVE_SELECTION		4
#define SAVE_ENTIRE_WHITEBOARD	5
#define READ_IN_A_FILE		6
#define QUIT			8

#define CUT			0    	/* EDIT_MENU item selections */
#define COPY			1
#define PASTE			2
#define PASTE_X_SELECTION	3
#define CLEAR			4
#define FATBITS_SELECTION	5
#define SELECT_VIS_AREA		7
#define SELECT_ALL		8
#define CLEAR_WHITEBOARD	10

#define LANGUAGE		0    	/* OPTIONS_MENU item selections */
#define SCROLLBAR_SETTINGS	1
#define MOUSE_OPTIONS		2
#define TELEPOINTER_LABEL	4
#define SUPER_SELECTION		5
#define BRUSH_SHAPES		6
#define LINE_SETTINGS		7
#define ERASER_OPTIONS		8
#define SQUARE_SETTINGS		9
#define OVAL_SETTINGS		10

#define INCR			0    	/* scrollbar motions */
#define DECR			1
#define GENERIC_MOVE		2

#define KNOCK_KNOCK_MESG	0    	/* message types */

#include <stdio.h>              /* standard i/o functions*/
#include <stdlib.h>             /* for "rand" call */
#include <ctype.h>              /* for character testing functions "isspace" */
#include <sys/types.h>          /* for "bind" system calls */
#include <sys/socket.h>         /* for socket calls */
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <netdb.h>

#include <string.h>             /* necessary for the strpbrk stuff*/
#include <X11/Xos.h>            /* "time.h" necessary for the "select" stuff*/
#include <X11/Xlib.h>           /* standard x defs*/
#include <X11/Xutil.h>          /* necessary for the XWMhints stuff*/
#include <X11/cursorfont.h>     /* we are gonna change the pointer*/

#include <X11/Intrinsic.h>	/* Xt include files */
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xm/MwmUtil.h>		/* NOTE: also found in X11/MwmUtil.h sometimes*/
#include <Xm/Protocols.h>	/* NOTE: also found in X11/Protocols.h */


#include <Xm/Xm.h>		/* Motif include files */
#include <Xm/MenuShell.h>
#include <Xm/CascadeB.h>
#include <Xm/Command.h>
#include <Xm/DrawingA.h>
#include <Xm/DrawnB.h>
#include <Xm/Frame.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/LabelG.h>
#include <Xm/MainW.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/Scale.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/SelectioB.h>
#include <Xm/SeparatoG.h>
#include <Xm/Text.h>
#include <Xm/ToggleBG.h>

struct generic_msg_struct
{
    int type;
    char newhostname[MAX_HOST_NAME_LENGTH];
};

struct knock_knock_msg_struct
{
    int type;
    char newhostname[MAX_HOST_NAME_LENGTH];
    int x, y;		/* x and y coord of wscrawl window */
};

static char *colors[] = {"white",  "magenta", "red", "blue", "cyan", 
			 "LightSteelBlue", "navy blue", "green", "coral", 
			 "light grey", "orange", "plum", "yellow", "black", 
			 "****"};

static char *fonts[] = {"fixed", "variable", "timR12", "helvO12", "courR12", 
			"courR14", "timBI18", "courR24", "timR24", "timBI24", 
			"ncenR24", "vbee-36", "vr-40", "vgl-40", "vsgn-57", 
			"****"};

static char *tools[] = {"pointer", "selection", "pencil", "type",
			"paint brush", "spray can", "eraser", "line",
			"outline square", "fill square", "outline oval", "fill oval"};

struct global_values_struct     /* shared amoung all the displays */
{
    int draw_area_height, draw_area_width;
    int sync_scrollbars_bool;   /* TRUE if all scrollbars are linked together*/
    int screen_dirty_bit;	/* TRUE if the screen has been drawn on */
    int edit_file_bool;		/* TRUE if we are editing a file on startup */
    char edit_filename[100];   	/* filename of edit file to edit */
};

struct mouse_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget label;		/* the label */
    Widget coordinates_toggle;	/* Show Mouse coordinates toggle */
    Widget telepointer_toggle;	/* Show telepointer toggle */
    Widget grid_toggle;		/* Show grid toggle */
    Widget close_button;	/* close button */
};

struct language_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget label;		/* the label */
    Widget german_button;	/* german button */
    Widget english_button;	/* english button */
    Widget ok_button;		/* ok button */
    Widget cancel_button;	/* cancel button */
    int current_language;	/* current language stored here */
};

struct fatbits_region_struct    /* info about selected region */
{
    int region_is_selected;	/* boolean */
    int x, y, width, height;    /* coordinates of original selection */
    int cur_x, cur_y;		/* current loc of selection (fatbit coord) */
    int cur_real_x, cur_real_y; /* current real loc of selection (pix coord) */
    XPoint orig_rubberband_point;
    XPoint fat_orig_rub_point;
    XPoint last_rubberband_point; 
    XPoint fat_last_rub_point;
    XPoint drag_offset;		/* user interface stuff */
    Widget win;
    Pixmap backing_store;  	/* backing store for all selection */
    GC surround_line_gc;	/* dashed line GC for every display */
    GC rubber_band_gc;	
    XImage *local_image;        /* keeps track of picture on client side */
};

struct fatbits_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget tool[3]; 		/* tools on the tool pallette */
    Widget dialog_form;		/* dialog form */
    Widget draw_area;		/* fatbits drawing area */
    Widget close_button;	/* close button */
    int input_mode;		/* current input mode, such as PENCILING */
    int pointer_state;		/* current pointer state such as PRESSED, etc */
    int pencil_bool;            /* TRUE if pencil is marking, FALSE if erasing*/
    unsigned long backgd_pixel; /* this is the pixel value of the background */
    XPoint last_scrawl_point;   /* last point drawn */
    int x, y;			/* upper left corner of the fatbits area */
    int width, height;          /* width and height of fatbits drawing area */
    Pixmap backing_store;       /* expose events are refreshed from this */
    XImage *local_image;        /* keeps track of picture on client side */
    Window eraser_win_id;	/* eraser window */
    int eraser_win_width;       /* eraser window width */
    struct fatbits_region_struct selected_region;
};

struct color_picker_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget label;		/* the label */
    Widget rslider;		/* R G B color sliders */
    Widget gslider;		
    Widget bslider;	
    int color_cell_allocated;   /* boolean to indicate this */
    unsigned long the_color_cell;
    GC the_gc;			/* GC for the example color box */
    Widget example_color;	/* example color area */
    Widget grab_button;		/* "Grab Color" button */
    Widget alloc_button;	/* "Allocate Color" button */
    Widget cancel_button;	/* cancel button */
};

struct eraser_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget erase_vis_button;	
    Widget erase_all_button;
    Widget label;		/* the label */
    Widget textfield;
    Widget ok_button;		/* ok button */
    Widget cancel_button;	/* cancel button */
};

struct brush_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget brush_shape[30];	/* brush shape buttons */
    Widget ok_button;		/* ok button */
};

struct scrollbar_dialog_struct  /* scrollbar settings */
{
    Widget the_dialog;		/* the actual dialog box */
    Widget label;	
    Widget scroll_sync_button;	
    Widget scroll_a_sync_button;	
    Widget cancel_button;	/* cancel button */
};

struct dirty_add_display_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget label;	
    Widget copy_all_button;	
    Widget copy_vis_button;	
    Widget clear_all_button;	
    char new_dispname_str[100];	
    Widget cancel_button;	/* cancel button */
};

struct attract_attention_dialog_struct  /* attract attention dialog */
{
    Widget the_dialog;		/* the actual dialog box */
    Widget label;	
    Widget ring_bell_button;	
    Widget flash_screen_button;	
    Widget close_button;	/* close button */
};

struct select_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget super_sel_button;	
    Widget freeze_sel_button;
    Widget wait_freeze_sel_button;
    int pointer_down;
    Widget cancel_button;	/* cancel button */
};

struct line_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    int line_width; 
};

struct square_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    int line_width; 
};

struct oval_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    int line_width; 
};


struct save_file_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget label;	
    Widget bitmap_button;	
    Widget image_button;
    Widget greyscale_ps_button;
    Widget ppm_button;
    int format_chosen;          /* last one of the above buttons pressed */
    Widget cancel_button;	/* cancel button */
    Widget file_selection_dialog; /* standard file selection dialog */
};

struct read_file_dialog_struct
{
    Widget the_dialog;		/* the actual dialog box */
    Widget label;	
    Widget bitmap_button;	
    Widget image_button;
    Widget text_file_button;
    Widget ppm_button;
    int format_chosen;          /* last one of the above buttons pressed */
    Widget cancel_button;	/* cancel button */
    Widget file_selection_dialog; /* standard file selection dialog */
};

struct char_node
{
    char the_char;
    int x, y;                	/*where this letter was typed (only for <CR>)*/
    struct char_node *next;  	/*pointer to the next character*/
};

struct type_struct
{
    XPoint cur_pos;		/* last point typed in this window */
    XPoint orig_pos;		/* original point typed in this window */
    int first_typed_letter_bool;/* TRUE if the next keypress is the first */
    XFontStruct *the_font_struct; /* font structure, should be per disp, maybe*/
    GC cursor_gc;        	/* GC for drawing the cursor */
    int prompt_width;		/* width of prompt */
    int char_height;		/* height between lines */
    struct char_node *type_history; /*history of all typed characters*/
};

struct region_struct            /* info about selected regions */
{
    int region_is_selected;	/* boolean */
    int region_has_moved;	/* dirty bit, also boolean */
    int x, y, width, height;    /* coordinates of original selection */
    int cur_x, cur_y;		/* current location of the selection */
    XPoint drag_offset;		/* user interface stuff */
    Widget selection_shell[MAX_NUM_DISPS]; /* in all of the displays */
    Widget selection_area[MAX_NUM_DISPS]; /* in all of the displays */
    Pixmap backing_store[MAX_NUM_DISPS];/* backing store for all windows */
    Pixmap clip_board[MAX_NUM_DISPS]; /* cut,copy,paste to and from this */
    int clip_board_width, clip_board_height; /* clipboard height + width */
    GC surround_line_gc[MAX_NUM_DISPS];	/* dashed line GC for every display */
    int dash_offset[MAX_NUM_DISPS]; /* dash offset */
    XtIntervalId timer_id[MAX_NUM_DISPS]; /* rotate line on timer events */
};

struct paintbrush_struct        /* holds paint brush related stuff */
{
    int paint_mode;             /* either NORMAL or BITMAP_BRUSH painting */
    Cursor paintb_curs[30];     /* the paint brush cursors */
    int which_paintb;           /* index of current paintbrush */
    int brush_width;            /* when mode is NORMAL, this indicates width */
    int num_points;             /* number of points in the bitmap brush */
    int x[MAX_NUM_BRUSH_POINTS];/* x coord of points in the bitmap brush */
    int y[MAX_NUM_BRUSH_POINTS];/* y coord of points in the bitmap brush */
};

struct rubberpointstruct        /* holds the rubberband cursor pixmap and dim */
{
    char pointer_str[50];	/* textual name of this person or display */
    int width;                  /* the width of the pointer */
    int height;                 /* the height of the pointer */
    int is_mapped_bool;         /* TRUE when this person's pointer is mapped */
};

struct menu_struct
{
    Widget menu_shell;		/* popup shell holds all "items" in menus */
    Widget menu_bar_button;    	/* buttons with "File", "Edit" */
    Widget menu_item[MAX_NUM_MENU_ITEMS];
    int selectable[MAX_NUM_MENU_ITEMS]; /* specifies which are unselectable */
    int menu_bar_inverted;	/* boolean, TRUE if menubar button is swapped */
    Pixel top_shadow_color;     /* of the menu buttons */
    Pixel bottom_shadow_color;  /* of the menu buttons */
    int num_menu_items;		/* number of items in this menu */
    int menu_bar_width;		/* width of widgets in the menubar */
    int menu_width;		/* width of actual pull down menu */
    int menu_bar_height;	/* height of widgets in the menubar */
    int menu_item_dim[MAX_NUM_MENU_ITEMS]; /* height of menu items */
};

struct disp_info_struct		/* one of these exists for each scrawler */
{
    int in_session_bool;	/* if this structure is being used */
    int show_pointer_coords;	/* TRUE if pointer coords should be drawn */
    int show_telepointer_always;/* TRUE if telepointer should always be drawn */
    int pointer_snap_to_grid;	/* TRUE if telepointer should always be drawn */
    int NUM_EFF_MENUS;
    char disp_name[50];		/* textual name of this display */
    char status_line_format[100]; /* status line message and format */
    char status1_line_format[100]; /* status line message for one user */
    int current_language;	/* the current language this interface is in */
    Pixmap backing_store;	/* expose events are refreshed from this */
    GC backing_store_gc;        /* a GC for various adminstrative ops */
    int input_mode;		/* PAINTING, TYPING, ERASING, etc */
    int pointer_state;		/* PRESSED, NOT_PRESSED */
    Widget app_shell;		/* top level shell */
    Widget main_window;		/* for all sorts of things */
    Widget status_area;		/* who is currently in this session */
    Widget help_menu_bar_button;/* help menu button */
    Widget help_dialog;         /* help dialog box */
    Widget swindow;		/* scrolled window widget */
    Widget vsbar, hsbar;	/* vertical and horizontal scroll bars */
    Widget pointer_x_coords_label;/* displays the pointer x coordinates */
    Widget pointer_y_coords_label;/* displays the pointer y coordinates */
    struct menu_struct menu[NUM_MENUS + 1]; /* one struct for each menu + 1 */
    Widget tool[MAX_NUM_TOOLS]; /* tools on the tool pallette */
    int orig_menu_num;	      	/* original menu selected */
    int cur_menu_num;	      	/* current menu selected */
    int cur_item_num;		/* current item selected */
    Widget add_display_dialog;  /* popup dialog prompting for display name */
    Widget change_pointer_dialog; /* popup dialog prompting for pointer name */
    Widget join_session_dialog; /* popup dialog prompting for joining session */
    Widget info_dialog;		/* popup info dialog */
    Widget error_dialog;	/* popup error dialog */
    struct language_dialog_struct language_dialog; /* language dialog */
    struct mouse_dialog_struct mouse_dialog; /* mouse options dialog */
    struct brush_dialog_struct brush_dialog; /* brush dialog */
    struct eraser_dialog_struct eraser_dialog; /* eraser dialog */
    struct scrollbar_dialog_struct scrollbar_dialog; /* scrollbar settings */
    struct attract_attention_dialog_struct attract_attention_dialog;
    struct dirty_add_display_dialog_struct dirty_add_display_dialog;
    struct color_picker_dialog_struct color_picker_dialog; /* color picker */
    struct fatbits_dialog_struct fatbits_dialog; /* fatbits editor */
    struct select_dialog_struct select_dialog; /* linewidth dialog */
    struct line_dialog_struct line_dialog; /* linewidth dialog */
    struct square_dialog_struct square_dialog; /* linewidth dialog */
    struct oval_dialog_struct oval_dialog; /* selection dialog */
    struct read_file_dialog_struct read_file_dialog; /* file type dialog */
    struct save_file_dialog_struct save_file_dialog; /* file type dialog */
    Display *disp;		/* the display this wscrawl window is on */
    Window draw_win_id;		/* window to be drawn in */
    Window eraser_win_id;	/* eraser window */
    Cursor pause_cursor;        /* pause cursor for all windows */
    int eraser_win_width;       /* width of the eraser window */
    int eraser_win_height;      /* height of the eraser window */
    int draw_win_width;		/* width of the drawing window */
    int draw_win_height;        /* height of the drawing window */
    Widget draw_area;		/* the drawing area widget */
    XtIntervalId spraypaint_timer_id; /* spray every couple of millisecs */
    GC win_gc[MAX_NUM_DISPS];	/* a GC for everybody */
    GC rubber_band_gc;        	/* a GC for various rubberbanding activities */
    GC super_rubber_band_gc;    /* a GC for super rubberbanding activities */
    GC menu_top_shadow_gc;	/* a GC for menu painting activities */
    GC menu_bottom_shadow_gc;	/* a GC for menu painting activities */
    GC menu_gc;    		/* a GC for misc menu like activities */
    char cur_color_str[50];	/* text name of the current color */
    char cur_font_str[256];	/* text name of the current font */
    unsigned long current_pixel;/* current painting pixel */
    XPoint last_scrawl_point;	/* last point scrawled in this window */
    XPoint last_telepointer_point; /* for the telepointer */
    XPoint orig_rubberband_point;/* original rubber band point */
    XPoint last_rubberband_point;/* last rubber band point */
    struct type_struct type_info;/* all the information about typing */
    struct rubberpointstruct rubber_pointer;  /* the rubber pointer */
    struct paintbrush_struct paintbrush; /* holds paint brush related stuff */
    struct region_struct selected_region; /* info about the selected region */
    int my_socket;		/* socket for getting knock-knocks on */
    int pointer_mapped;		/* cursor tag for this user in drawing area */
    Pixmap icon_pix;		/* color pixmap to put in icon window */
    char icon_fg_str[50];	/* foreground color of icon */
    char icon_bg_str[50];       /* background color of icon */
};

